ad_library {

    Implementation of the portal_datasource contract (portlet) for the todo package

    @author Emmanuelle RAffenne (eraffenne@gmail.com)

}


namespace eval todo_portlet {}


ad_proc todo_portlet::add_self_to_page {

    -portal_id:required
    -package_id:required
    -param_action:required
    {-force_region ""}
    {-page_name ""}

} {
    Adds itself to the given page returns an element_id
} {

    set element_id [portal::add_element_parameters \
                        -portal_id $portal_id \
                        -portlet_name [todo_portlet::get_my_name] \
                        -value $package_id \
                        -force_region $force_region \
                        -page_name $page_name \
                        -pretty_name [todo_portlet::get_pretty_name] \
                        -param_action $param_action]

    return $element_id

}

ad_proc todo_portlet::get_my_name {
} {
    Get the portlet name
} {
    return "todo_portlet"
}

ad_proc todo_portlet::get_pretty_name {
} {
    Get the pretty name of the portlet
} {
    return "#todo-portlet.portlet_pretty_name#"
}

ad_proc todo_portlet::remove_self_from_page {
    -portal_id:required
    -package_id:required
} {
    remove itself from the given page
} {

    portal::remove_element_parameters \
        -portal_id $portal_id \
        -portlet_name [todo_portlet::get_my_name] \
        -value $package_id

    return

}

ad_proc todo_portlet::show {
    cf
} {
    Render the portal element returning a chunk of HTML
} {
   
    portal::show_proc_helper \
        -package_key "todo-portlet" \
        -config_list $cf \
        -template_src "todo-portlet"
}

ad_proc todo_portlet::edit {
    -element_id:required
} {
    Returns the edit html *not implemented*
} {
    return ""
}

ad_proc todo_portlet::link {
} {
    Get the link (ie. the href target) for this datasource *not implemented*
} {
    return ""
}
